
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef sick_ERROR_H
#define sick_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_sick    (3500)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_sick_FILE_NOT_FOUND       H2_ENCODE_ERR(M_sick      , 1)
#define S_sick_BAD_PARAMS           H2_ENCODE_ERR(M_sick      , 2)
#define S_sick_CANNOT_WRITE_FILE    H2_ENCODE_ERR(M_sick      , 3)
#define S_sick_CANNOT_OPEN_FILE     H2_ENCODE_ERR(M_sick      , 4)
#define S_sick_isnot_initialized    H2_ENCODE_ERR(M_sick      , 5)
#define S_sick_reset_error          H2_ENCODE_ERR(M_sick      , 6)
#define S_sick_serial_output_error  H2_ENCODE_ERR(M_sick      , 7)
#define S_sick_serial_input_error   H2_ENCODE_ERR(M_sick      , 8)
#define S_sick_cannot_connect_to_pom H2_ENCODE_ERR(M_sick      , 9)
#define S_sick_bad_tram             H2_ENCODE_ERR(M_sick      , 10)
#define S_sick_cannot_find_baud_rate H2_ENCODE_ERR(M_sick      , 11)
#define S_sick_time_out             H2_ENCODE_ERR(M_sick      , 12)
#define S_sick_fatal_error          H2_ENCODE_ERR(M_sick      , 13)


/* std errors */
#define S_sick_stdGenoM_ACTIVITY_INTERRUPTED       229434369   /* 3500<<16 | 0x8000 | 100<<8 | 1 */
#define S_sick_stdGenoM_TOO_MANY_ACTIVITIES        229434370   /* 3500<<16 | 0x8000 | 100<<8 | 2 */
#define S_sick_stdGenoM_ACTIVITY_FAILED            229434371   /* 3500<<16 | 0x8000 | 100<<8 | 3 */
#define S_sick_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 229434372   /* 3500<<16 | 0x8000 | 100<<8 | 4 */
#define S_sick_stdGenoM_UNKNOWN_ACTIVITY           229434373   /* 3500<<16 | 0x8000 | 100<<8 | 5 */
#define S_sick_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 229434374   /* 3500<<16 | 0x8000 | 100<<8 | 6 */
#define S_sick_stdGenoM_SYSTEM_ERROR               229434375   /* 3500<<16 | 0x8000 | 100<<8 | 7 */
#define S_sick_stdGenoM_ACTIVITY_ALREADY_ENDED     229434376   /* 3500<<16 | 0x8000 | 100<<8 | 8 */
#define S_sick_stdGenoM_WAIT_INIT_RQST             229434377   /* 3500<<16 | 0x8000 | 100<<8 | 9 */
#define S_sick_stdGenoM_CONTROL_CODEL_ERROR        229434378   /* 3500<<16 | 0x8000 | 100<<8 | 10 */
#define S_sick_stdGenoM_EXEC_TASK_SUSPENDED        229434379   /* 3500<<16 | 0x8000 | 100<<8 | 11 */
#define S_sick_stdGenoM_BAD_BLOCK_TYPE             229434380   /* 3500<<16 | 0x8000 | 100<<8 | 12 */
#define S_sick_stdGenoM_BAD_POSTER_TYPE            229434381   /* 3500<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define SICK_H2_ERR_MSGS {\
    {"FILE_NOT_FOUND", 1}, \
    {"BAD_PARAMS", 2}, \
    {"CANNOT_WRITE_FILE", 3},\
    {"CANNOT_OPEN_FILE", 4},\
    {"isnot_initialized", 5},\
    {"reset_error", 6},\
    {"serial_output_error", 7},\
    {"serial_input_error", 8},\
    {"cannot_connect_to_pom", 9},\
    {"bad_tram", 10},\
    {"cannot_find_baud_rate", 11},\
    {"time_out", 12},\
    {"fatal_error", 13},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int sickRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
