/*
 * Copyright (C) 1998 LAAS/CNRS -- RIA --
 *
 * Maher Khatib - Tue Feb  3 1998
 *
 */
#ifndef _SICK_CONST_H_
#define _SICK_CONST_H_


/* ------------------------------   XR4000 ------------------------------ */
#ifdef XR4000 
# define SICK_SCAN_TASK_PERIOD     (20)
# define SICK_NOT_CONTROLLABLE

/* ------------------------------   ATRV ------------------------------ */
#elif defined(ATRV)
# define SICK_SCAN_TASK_PERIOD     (20)
# define SICK_UPSIDE_DOWN
// Because of the position of sick on Dala, the robot 
// is in the scanning range of the sick (-90,90), so we have to limit this range
// for Dala, you have to do : genom -t -DATRV sick.gen
# define SICK_MIN_ANGLE DEG_TO_RAD(-90+11)
# define SICK_MAX_ANGLE DEG_TO_RAD(90-9)

/* ------------------------   H2 and H2BIS ------------------------------ */
#elif defined (H2) || defined (H2BIS)
# ifdef SICK2
/* -- H2-TRAILER ----- */
#  define SICK_SCAN_TASK_PERIOD     (40)
#  define TRAILER
#  define SICK_DIST_SICK_HITCH_POINT 0.966  /* from trailer hitch point */
// #  define SICK_SERIAL_DEVICE_NAME	  "/tyCo/1"
// #  define SICK_NOT_CONTROLLABLE */
// #  define SICK_X_POS	       	      (-SICK_DIST_SICK_HITCH_POINT) 
// #  define SICK_Y_POS		      (0.0)
// #  define SICK_THETA_POS	      (PI)
# else // SICK2
#  define SICK_SCAN_TASK_PERIOD     (20)
// #  define SICK_SERIAL_DEVICE_NAME	  "/tyCo/1"
// #  define SICK_X_POS                (.45)
// #  define SICK_Y_POS                (0.0)
// #  define SICK_THETA_POS            (0.0)
/* Modif Florent: trick to desactivate last laser beam to get rid 
   of an artifact */
/* #  define SICK_MAX_ANGLE             DEG_TO_RAD(90-2) */
# endif // SICK2

#else // not XR4000, ATRV, H2, H2BIS
# define SICK_SCAN_TASK_PERIOD     (10)
#endif

/* ------------------------------   common ------------------------------ */

/* scanning task priority */
#define SICK_SCAN_TASK_PRIORITY        (20)

/* stack size */
#define SICK_SCAN_TASK_STACK_SIZE      (16384) /* 16KB */

/*
#define SICK_FRAME_DEFAULT {SICK_X_POS, SICK_Y_POS, SICK_THETA_POS}
*/

/**
 ** SEGMENTATION default params 
 **/

/* cf conf_sg_host in segkit/segmentation/lasegm.c */
#define SICK_DEFAULT_SEG_LEAST_SQUARE_THRES   0.01
#define SICK_DEFAULT_SEG_DIST_MAX_PTS         0.2
#define SICK_DEFAULT_SEG_NB_MIN_PTS           4

/* LASER PARAMETERS */
#define SICK_SEG_RHO_MAX 32. /* data more than D_MAX meters away are no good */

#define  SICK_RHO_MAX 32. /* data more than D_MAX meters away are no good */
#define  SICK_VAR_R  0.0009
#define  SICK_VAR_RO 0.0
#ifndef SQR
#define SQR(x) ((x)*(x))
#endif
#ifndef DEG_TO_RAD
#define DEG_TO_RAD(x) ((x)*M_PI/180.0)
#endif  /* DEG_TO_RAD */
#define  SICK_VAR_O  SQR(DEG_TO_RAD(0.3))

/**
 ** READ DATA BY FILE
 **/

#define SICK_DEFAULT_SICK_DATA_BASE_NAME "/usr/local/hilare2/src/modules/sick/data/sick020402/sick"
#define SICK_DEFAULT_SICK_DATA_FILE_NUM 1

/**
 ** SIMULATION
 **/

#endif /* _SICK_CONST_H_ */
